// ConnectionPage.cpp : implementation file
//

#include "stdafx.h"
#include "GPIODBC.h"
#include ".\connectionpage.h"
#include ".\querywizard.h"


// CConnectionPage dialog

IMPLEMENT_DYNAMIC(CConnectionPage, CPropertyPage)
CConnectionPage::CConnectionPage()
	: CPropertyPage(CConnectionPage::IDD)
	, m_strDSN(_T(""))
	, m_strUser(_T(""))
	, m_strPwd(_T(""))
	, m_nMode(0)
	, m_strConnectionString(_T(""))
{
	m_strDSN = AfxGetApp()->GetProfileString("History", "dsn");
	m_nMode = AfxGetApp()->GetProfileInt("History", "mode", (int) CQueryWizard::browseConnection);
}

CConnectionPage::~CConnectionPage()
{
}

void CConnectionPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_DSN_EDIT, m_strDSN);
	DDX_Text(pDX, IDC_USER_EDIT, m_strUser);
	DDX_Text(pDX, IDC_PWD_EDIT, m_strPwd);
	DDX_Radio(pDX, IDC_CONNECTIONMODE_RADIO, m_nMode);
	DDX_Text(pDX, IDC_CONNECTIONSTRING_EDIT, m_strConnectionString);
}


BEGIN_MESSAGE_MAP(CConnectionPage, CPropertyPage)
	ON_BN_CLICKED(IDC_BROWSEODBCSOURCE_BUTTON, OnBnClickedBrowseodbcsourceButton)
	ON_BN_CLICKED(IDC_CONNECTIONMODE_RADIO, OnBnClickedConnectionmodeRadio)
	ON_BN_CLICKED(IDC_CONNECTIONMODE_RADIO2, OnBnClickedConnectionmodeRadio)
	ON_BN_CLICKED(IDC_CONNECTIONMODE_RADIO3, OnBnClickedConnectionmodeRadio)
END_MESSAGE_MAP()


// CConnectionPage message handlers

BOOL CConnectionPage::OnSetActive()
{
	((CPropertySheet*)GetParent())->SetWizardButtons(PSWIZB_NEXT);

	OnBnClickedConnectionmodeRadio();

	return CPropertyPage::OnSetActive();
}

LRESULT CConnectionPage::OnWizardNext()
{
	if (UpdateData())
	{
		((CQueryWizard*)GetParent())->m_strDSN = m_strDSN;
		((CQueryWizard*)GetParent())->m_strUser = m_strUser;
		((CQueryWizard*)GetParent())->m_strPwd = m_strPwd;

		((CQueryWizard*)GetParent())->m_connectionMode = (CQueryWizard::ConnectionMode) m_nMode;
		((CQueryWizard*)GetParent())->m_strConnectionString = m_strConnectionString;

		AfxGetApp()->WriteProfileString("History", "dsn", m_strDSN);
		AfxGetApp()->WriteProfileInt("History", "mode", m_nMode);

		if ( ((CQueryWizard*)GetParent())->TestConnection() )
			return CPropertyPage::OnWizardNext();
	}

	return 1;
}

void CConnectionPage::OnBnClickedBrowseodbcsourceButton()
{
	if ( ((CQueryWizard*)GetParent())->BrowseConnection() )
	{
		m_strConnectionString = ((CQueryWizard*)GetParent())->m_db.GetConnect();
		UpdateData(FALSE);
	}
}

void CConnectionPage::OnBnClickedConnectionmodeRadio()
{
	UpdateData(TRUE);
	// Show/Hide controls
	if (m_nMode == (int) CQueryWizard::browseConnection)
	{
		GetDlgItem(IDC_DSNGROUP_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_DSN_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_USER_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_PWD_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_DSN_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_USER_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PWD_EDIT)->EnableWindow(FALSE);

		GetDlgItem(IDC_CONNECTIONSTRING_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_BROWSEODBCSOURCE_BUTTON)->EnableWindow(FALSE);
	}
	else if (m_nMode == (int) CQueryWizard::simpleConnection)
	{
		GetDlgItem(IDC_DSNGROUP_STATIC)->EnableWindow(TRUE);
		GetDlgItem(IDC_DSN_STATIC)->EnableWindow(TRUE);
		GetDlgItem(IDC_USER_STATIC)->EnableWindow(TRUE);
		GetDlgItem(IDC_PWD_STATIC)->EnableWindow(TRUE);
		GetDlgItem(IDC_DSN_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_USER_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_PWD_EDIT)->EnableWindow(TRUE);

		GetDlgItem(IDC_CONNECTIONSTRING_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_BROWSEODBCSOURCE_BUTTON)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_DSNGROUP_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_DSN_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_USER_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_PWD_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_DSN_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_USER_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PWD_EDIT)->EnableWindow(FALSE);

		GetDlgItem(IDC_CONNECTIONSTRING_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_BROWSEODBCSOURCE_BUTTON)->EnableWindow(TRUE);
	}
}
