// FieldDefinitionPage.cpp : implementation file
//

#include "stdafx.h"
#include "GPIODBC.h"
#include ".\fielddefinitionpage.h"
#include ".\querywizard.h"


// CFieldDefinitionPage dialog

IMPLEMENT_DYNAMIC(CFieldDefinitionPage, CPropertyPage)
CFieldDefinitionPage::CFieldDefinitionPage()
	: CPropertyPage(CFieldDefinitionPage::IDD)
	, m_nXCol(0)
	, m_nYCol(1)
{
}

CFieldDefinitionPage::~CFieldDefinitionPage()
{
}

void CFieldDefinitionPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SAMPLE_LIST, m_wndSample);
	DDX_Control(pDX, IDC_LONG_COMBO, m_wndLong);
	DDX_Control(pDX, IDC_LAT_COMBO, m_wndLat);
	DDX_CBIndex(pDX, IDC_LONG_COMBO, m_nXCol);
	DDX_CBIndex(pDX, IDC_LAT_COMBO, m_nYCol);
}


BEGIN_MESSAGE_MAP(CFieldDefinitionPage, CPropertyPage)
END_MESSAGE_MAP()


// CFieldDefinitionPage message handlers

BOOL CFieldDefinitionPage::OnSetActive()
{
	((CPropertySheet*)GetParent())->SetWizardButtons(PSWIZB_BACK | PSWIZB_FINISH);

	ReadTestData();

	return CPropertyPage::OnSetActive();
}


bool CFieldDefinitionPage::ReadTestData()
{
	m_wndSample.DeleteAllItems();
	while (m_wndSample.DeleteColumn(0))
		;
	m_wndLong.ResetContent();
	m_wndLat.ResetContent();

	try
	{
		CRecordset *prs = ((CQueryWizard*)GetParent())->m_pRS;
		if (!prs)
			return false;

		prs->MoveFirst();

		CString str;
		CODBCFieldInfo info;
		short nFieldCount = prs->GetODBCFieldCount();

		// Set-up headers
		for (short f = 0; f < nFieldCount; ++f)
		{
			prs->GetODBCFieldInfo(f, info);
			m_wndSample.InsertColumn(f, info.m_strName, LVCFMT_LEFT, 100);
			str.Format("%02d: %s", f+1, (LPCTSTR) info.m_strName);
			m_wndLong.AddString(str);
			m_wndLat.AddString(str);
		}
		m_wndLong.SetCurSel(m_nXCol);
		m_wndLat.SetCurSel(m_nYCol);

		// Add sample data
		for (int i = 0; i < 6 && !prs->IsEOF(); ++i)
		{
			prs->GetFieldValue((short) 0, str);
			m_wndSample.InsertItem(i, str);
			for (short f = 1; f < nFieldCount; ++f)
			{
				prs->GetFieldValue(f, str);
				m_wndSample.SetItemText(i, f, str);
			}
			prs->MoveNext();
		}
		return true;
	}
	catch (CDBException *ex)
	{
		ex->ReportError();
		ex->Delete();
	}

	return false;
}



BOOL CFieldDefinitionPage::OnWizardFinish()
{
	if (UpdateData())
	{
		if (m_nXCol == CB_ERR || m_nYCol == CB_ERR)
			AfxMessageBox(_T("Please select east and north columns."), MB_OK | MB_ICONERROR);
		else
		{
			((CQueryWizard*)GetParent())->m_nXCol = m_nXCol;
			((CQueryWizard*)GetParent())->m_nYCol = m_nYCol;

			return CPropertyPage::OnWizardFinish();
		}
	}

	return FALSE;
}
