// QueryPage.cpp : implementation file
//

#include "stdafx.h"
#include "GPIODBC.h"
#include ".\querypage.h"
#include ".\querywizard.h"


// CQueryPage dialog

IMPLEMENT_DYNAMIC(CQueryPage, CPropertyPage)
CQueryPage::CQueryPage()
	: CPropertyPage(CQueryPage::IDD)
	, m_recentQueries(0, "QueryHistory", "Query%d", 12)
	, m_strQuery(_T("SELECT *\r\nFROM aTable\r\nWHERE 1=1"))
{
	m_recentQueries.ReadList();
}

CQueryPage::~CQueryPage()
{
}

void CQueryPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_QUERY_EDIT, m_strQuery);
	DDX_Control(pDX, IDC_QUERY_EDIT, m_wndQuery);
	DDX_Control(pDX, IDC_QUERYHISTORY_COMBO, m_wndHistory);
}


BEGIN_MESSAGE_MAP(CQueryPage, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_QUERYHISTORY_COMBO, OnCbnSelchangeQueryhistoryCombo)
END_MESSAGE_MAP()


// CQueryPage message handlers

BOOL CQueryPage::OnSetActive()
{
	((CPropertySheet*)GetParent())->SetWizardButtons(PSWIZB_BACK | PSWIZB_NEXT);

	m_recentQueries.UpdateComboBox(&m_wndHistory);

	return CPropertyPage::OnSetActive();
}

LRESULT CQueryPage::OnWizardNext()
{
	if (UpdateData())
	{
		CString q = m_strQuery;
		q = q.TrimLeft();
		if (q.Left(6).CompareNoCase(_T("SELECT")) != 0)
		{
			AfxMessageBox(_T("This does not look like an SQL SELECT statement."), MB_OK | MB_ICONERROR);
			return FALSE;
		}

		((CQueryWizard*)GetParent())->m_strQuery = m_strQuery;

		if ( ((CQueryWizard*)GetParent())->TestQuery() )
		{
			m_recentQueries.Add(m_strQuery);
			m_recentQueries.WriteList();
			return CPropertyPage::OnWizardNext();
		}
	}

	return 1;
}

BOOL CQueryPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_fontQuery.CreateStockObject(OEM_FIXED_FONT);

	// We need to post the message since MFC does something with
	// this control after this function exits
	m_wndQuery.PostMessage(EM_SETSEL, 15, -1);
	m_wndQuery.SetFont(&m_fontQuery);

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CQueryPage::OnCbnSelchangeQueryhistoryCombo()
{
	int nSel = m_wndHistory.GetCurSel();
	if (nSel == CB_ERR)
		return;

	m_strQuery = m_recentQueries[nSel];

	UpdateData(FALSE);
}
