// QueryWizard.cpp : implementation file
//

#include "stdafx.h"
#include "GPIODBC.h"
#include "QueryWizard.h"


// CQueryWizard

IMPLEMENT_DYNAMIC(CQueryWizard, CPropertySheet)
CQueryWizard::CQueryWizard(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	: m_pRS(NULL)
	, CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_page1);
	AddPage(&m_page2);
	AddPage(&m_page3);
	SetWizardMode();
}

CQueryWizard::CQueryWizard(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	: m_pRS(NULL)
	, CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_page1);
	AddPage(&m_page2);
	AddPage(&m_page3);
	SetWizardMode();
}

CQueryWizard::~CQueryWizard()
{
	delete m_pRS;
}


BEGIN_MESSAGE_MAP(CQueryWizard, CPropertySheet)
END_MESSAGE_MAP()


// CQueryWizard message handlers

bool CQueryWizard::TestConnection()
{
	CString strConnString;
	DWORD dwOptions = CDatabase::openReadOnly;

	if (m_connectionMode == browseConnection)
	{
		strConnString = "DSN=" + m_strDSN + ";UID=" + m_strUser + ";PWD=" + m_strPwd;
		dwOptions |= CDatabase::forceOdbcDialog;
	}
	else if (m_connectionMode == simpleConnection)
	{
		if (!m_strDSN.IsEmpty())
		{
			strConnString = "DSN=" + m_strDSN + ";UID=" + m_strUser + ";PWD=" + m_strPwd;
			dwOptions |= CDatabase::noOdbcDialog;
		}
	}
	else
	{
		if (!m_strConnectionString.IsEmpty())
		{
			strConnString = m_strConnectionString;
			dwOptions |= CDatabase::noOdbcDialog;

			// Workaround to avoid strange ODBC error regarding how
			// connection strings should be constructed
			const TCHAR _afxODBCTrail[] = _T("ODBC;");
			if (strConnString.Left(5).CompareNoCase(_afxODBCTrail) == 0)
			{
				strConnString = strConnString.Mid(5);
			}
		}
	}

	try
	{
		m_db.Close();
		if (m_db.OpenEx(strConnString, dwOptions))
			return true;
	}
	catch (CDBException *ex)
	{
		ex->ReportError();
		ex->Delete();
	}

	return false;
}


bool CQueryWizard::BrowseConnection()
{
	try
	{
		m_db.Close();
		if (m_db.OpenEx(NULL, CDatabase::openReadOnly))
			return true;
	}
	catch (CDBException *ex)
	{
		ex->ReportError();
		ex->Delete();
	}

	return false;
}


bool CQueryWizard::TestQuery()
{
	delete m_pRS;
	m_pRS = NULL;
	try
	{
		ASSERT(m_db.IsOpen());
		m_pRS = new CRecordset(&m_db);
		if (m_pRS->Open(CRecordset::snapshot, m_strQuery))
//		if (m_pRS->Open(CRecordset::dynaset, m_strQuery))
		{
			if (!m_pRS->IsBOF())
				return true;
			else
				AfxMessageBox(_T("The query resulted in no matches."), MB_OK | MB_ICONERROR);
		}
	}
	catch (CDBException *ex)
	{
		ex->ReportError();
		ex->Delete();
	}
	delete m_pRS;
	m_pRS = NULL;

	return false;
}

