#pragma once


#include "./connectionpage.h"
#include "./querypage.h"
#include "./fielddefinitionpage.h"


// CQueryWizard

class CQueryWizard : public CPropertySheet
{
	DECLARE_DYNAMIC(CQueryWizard)

public:
	CQueryWizard(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CQueryWizard(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	virtual ~CQueryWizard();

	int m_nXCol;
	int m_nYCol;

	CRecordset *m_pRS;
protected:
	CDatabase m_db;
	CString m_strDSN, m_strUser, m_strPwd, m_strQuery, m_strConnectionString;

	bool TestConnection();
	bool BrowseConnection();
	bool TestQuery();

	enum ConnectionMode
	{
		browseConnection,
		simpleConnection,
		connectionStringConnection
	};

	ConnectionMode m_connectionMode;

	CConnectionPage m_page1;
	CQueryPage m_page2;
	CFieldDefinitionPage m_page3;

	friend class CConnectionPage;
	friend class CQueryPage;

	DECLARE_MESSAGE_MAP()
};


