// RecentStringList.cpp : implementation file
//

#include "stdafx.h"
#include "GPIODBC.h"
#include "RecentStringList.h"


// CRecentStringList

CRecentStringList::CRecentStringList(UINT nStart, LPCTSTR lpszSection,
		LPCTSTR lpszEntryFormat, int nSize)
		: CRecentFileList(nStart, lpszSection, lpszEntryFormat, nSize)
{
}

CRecentStringList::~CRecentStringList()
{
}


// CRecentStringList member functions
void CRecentStringList::Add(LPCTSTR lpszString)
{
	ASSERT(m_arrNames != NULL);
	ASSERT(AfxIsValidString(lpszString));

	TCHAR szTemp[] = "";
	if ( lpszString == NULL )
	{
		ASSERT(FALSE);
		lpszString = szTemp;
	}

	// update the MRU list, if an existing MRU string matches string
	int iMRU;
	for (iMRU = 0; iMRU < m_nSize-1; iMRU++)
	{
		if (::lstrcmp(m_arrNames[iMRU], lpszString) == 0)
			break;      // iMRU will point to matching entry
	}
	// move MRU strings before this one down
	for (; iMRU > 0; iMRU--)
	{
		ASSERT(iMRU > 0);
		ASSERT(iMRU < m_nSize);
		m_arrNames[iMRU] = m_arrNames[iMRU-1];
	}
	// place this one at the beginning
	m_arrNames[0] = lpszString;
}


void CRecentStringList::UpdateComboBox(CComboBox *pwndCombo, bool bResetContents)
{
	ASSERT(pwndCombo != NULL);

	if (bResetContents)
		pwndCombo->ResetContent();

	for (int i = 0; i < GetSize(); ++i)
	{
		CString str = operator[](i);
		str.Replace("\r\n", " ");
		pwndCombo->AddString(str);
	}
}

