// ShapePointCreator.cpp: implementation of the CShapePointCreator class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ShapePointCreator.h"
#include "shapeobjects.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//*******************************************************************************
// Name : CShapePointCreator
// Desc : Constructor
//*******************************************************************************
CShapePointCreator::CShapePointCreator(size_t nRecordNumber) :
	m_nRecordNumber(nRecordNumber + 1) // This is a 1-based index
{

}


//*******************************************************************************
// Name : ~CShapePointCreator
// Desc : Destructor
//*******************************************************************************
CShapePointCreator::~CShapePointCreator()
{

}


//*******************************************************************************
// Name : GetAllocSizeBytes
// Desc :
//*******************************************************************************
size_t CShapePointCreator::GetAllocSizeBytes() const
{
	return sizeof(SShapePointRecord);
}


//*******************************************************************************
// Name : Write
// Desc :
//*******************************************************************************
bool CShapePointCreator::Write(void* pMem, double x, double y)
{
	if (pMem != NULL)
	{
		// Write record header
		SShapePointRecord *s = reinterpret_cast<SShapePointRecord*>(pMem);
		s->m_recordNumber = ByteSwitchInt(m_nRecordNumber);
		s->m_contentLength = ByteSwitchInt(GetAllocSizeBytes() - sizeof(size_t)*2); // Remove record header length
		s->IntShapeType = Shape_Point;

		// Write point data
		s->m_x = x;
		s->m_y = y;

		return true;
	}

	return false;
}


//*******************************************************************************
// Name : SetNewRecordNumber
// Desc :
//*******************************************************************************
void CShapePointCreator::SetNewRecordNumber(void* pMem, size_t nRecordNumber)
{
	SShapePointRecord *s = reinterpret_cast<SShapePointRecord*>(pMem);
	s->m_recordNumber = ByteSwitchInt(nRecordNumber + 1);
}


//*******************************************************************************
// Name : UpdateCoordinate
// Desc : 
//*******************************************************************************
void CShapePointCreator::UpdateCoordinate(void* pMem, double x, double y)
{
	SShapePointRecord *s = reinterpret_cast<SShapePointRecord*>(pMem);

	// Write point data
	s->m_x = x;
	s->m_y = y;
}

